#!/usr/bin/perl

# Chargaff.pl -- finding Chargaff's numbers

#-----------------------------------------------------------------------
#-----------------------------------------------------------------------
=pod
=head1 NAME




=head1 DESCRIPTION

=head2 SUMMARY

You write a summary here.

=head2 INPUT

A (FASTA format) text file of DNA sequence data where the initial line is
a header followed by lines with 70 nucleotides per line.
This program removes the header line and all newlines.

MacOS TextWrangler users: (see directions near bottom in getDNA() )


=head2 OUTPUT

To CONSOLE (screen):


=head1 AUTHORS

your name goes here


=head1 MODIFICATION HISTORY

=head3 Sept 16, 2009 (mdl) -- provided some help in this Starter Kit

=head3 (add your modification dates and notes here)

=cut

#-----------------------------------------------------------------------
#-----------------------------------------------------------------------

# be careful
use strict;
use warnings;

use File::Spec;		# possibly needed for MacOS TextWrangler (see line #185)

# ------------- DECLARE VARIABLES -------------------------------------
my $sequence;               # will hold the DNA sequence to search
my $sequenceLength;         # to hold the total number of nucleotides to search

my $numA;                   # will hold the number of Adenine's (A) found
my $numC;
my $numG;
my $numT;

my $probOfA;          		# to hold the probability of As in the sequence
my $probOfC;
my $probOfG;
my $probOfT;


my $percentageOfA;          # to hold the percentages of As in the sequence
my $percentageOfC;
my $percentageOfG;
my $percentageOfT;

my $logLikelihood;			# log-likelihood of a certain 8-mer

# you include any others you need here ...





#-----------------------------------------------------------------------



# get the DNA sequence stored in a Perl string
$sequence = getDNA("test1.fna");



# find and store the respective counts of the four nucleotides
# Note: the tr (transliterate) utility can return counts of particular characters 

# find number of Adenine's (A)    
$numA = ($sequence =~ tr/A/A/);

# find number of Cytosine's (C) 
$numC = ($sequence =~ tr/C/C/);








#-----------------------------------------------------------------------
# calculate the proportion of each nucleotide here




#-----------------------------------------------------------------------
# calculate the percentage of each nucleotide here




#-----------------------------------------------------------------------
# make a neat printout of Chargaff's numbers

print "Number of As: \t\t $numA \n";

print "Number of Cs: \t\t $numC \n";



#-----------------------------------------------------------------------
# # using percents you calculated above, calculate the log-likelihood of ACGTACGT



#-----------------------------------------------------------------------
# compute the length of a piece of DNA in centimeters (cm)

my $thisManyBases = 1 * 10**6; # number of starting base pairs
printf "\n\nYour long sequence has %5.1e bases.\n\n", $thisManyBases;


# you finish the calculation below ...




# end of Chargaff.pl program




# ------- Do NOT change the Perl below this line --------------------------------


#-------------------- Subroutine for you to use -----------------------
#
# This subroutine (sometimes called a function) below is ready for you to
# use in your program. Think of this routine as a "button on your
# calculator" ... this is ready for to use. When you "use" this
# routine, we say "your program is CALLING" for the use of that routine.
#-----------------------------------------------------------------------

#-------\
# getDNA \
#-----------------------------------------------------------------------
# Subroutine to open a FASTA formatted file of DNA sequence, remove
# first (header) line, newline characters, and return as one big string.
#
# A sample of how you might "call" this subroutine from your program above
# to 'get' the DNA for chromosome III of the worm, C.elegans.
#
#                  $sequence = getDNA("worm_III.fna");

sub getDNA
{
	my $filename = shift(@_);  # get the filename sent
 
  my $firstline;             # holds header (first) line of file with name, etc
  my $DNAsequence;           # holds the entire sequence of DNA in the file
                             # to return
  my @lines;                 # used to hold ALL the lines from the DNA file
 
 # --------------------------------------------------------------------------
 # MacOS: If you are using TextWrangler, uncomment the next two lines
 
 #my @path	= File::Spec->splitdir( File::Spec->rel2abs($0) );
 #$filename	= File::Spec->catfile( @path[0 .. $#path - 1], $filename );
 # --------------------------------------------------------------------------

  # try to open the file; if no file by that name, print a warning and exit
  open (FNAFILE, "$filename");
  if ( !($firstline = <FNAFILE>) ) {
    print "Can NOT open the file called: $filename \n";
    exit();
  }
  
  @lines = <FNAFILE>;                   # read all the remaining lines
  chomp @lines;                         # remove all the newlines at the end
  $DNAsequence = join( '', @lines);     # concatenate all the lines into 1 string
  
  # if we get to here, print SUCCESS and the first line of the FASTA file
  print "Successfully opened and read the file: \t $filename \n";
  print "$firstline \n\n";
  
  return $DNAsequence;
}
#-----------------------------------------------------------------------



